# -*- coding: iso-8859-15 -*-
# $Id: $
## Install.py - Plone QuickInstaller method for product

from Products.Archetypes.Extensions.utils import install_subskin
from Products.CMFPaypalHelper import PROJECTNAME, product_globals
from Products.CMFPaypalHelper.PaypalTool import PaypalTool
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO

configlets = (
    {'id' : 'paypal_prefs'
     , 'name' : 'Paypal configuration'
     , 'action' : 'string:${portal_url}/paypal_prefs'
     , 'category' : 'Products'
     , 'appId' : PROJECTNAME
     , 'permission' : "Manage portal"
     , 'imageUrl' : 'site_icon.gif'
          },)

def addConfiglets(self, out):
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in configlets:
            out.write('Adding configlet %s\n' % conf['id'])
            configTool.registerConfiglet(**conf)
            
def removeConfiglets(self, out):
    configTool = getToolByName(self, 'portal_controlpanel', None)
    if configTool:
        for conf in configlets:
            out.write('Removing configlet %s\n' % conf['id'])
            configTool.unregisterConfiglet(conf['id'])
            
def install_skins(self, out, skinsdir, product_globals):
    """ Install product skins and register them to portal_skins."""

    print >> out, '* Installing and registering layers from directory %s\n' % skinsdir

    install_subskin(self, out, globals=product_globals)

def install_tool(self, out, product_globals):
    """ Setup a tool in the Plone site."""

    # Add the tool if it does not already exist.
    bt = getToolByName(self, PaypalTool.id, None)
    if bt is None:
        print >> out, "* Installing %s as %s\n" % (PaypalTool.meta_type, PaypalTool.id)
        portal = getToolByName(self, 'portal_url').getPortalObject()
        addTool = portal.manage_addProduct[PROJECTNAME].manage_addTool
        addTool(type = PaypalTool.meta_type)

        bt = getToolByName(self, PaypalTool.id)

        # Restrict access to the tool to the Manager only.
        bt.manage_permission('View', ['Manager'])

                                                                
def install(self):
    out = StringIO()
    install_skins(self, out, 'skins', product_globals)
    install_tool(self, out, product_globals)
    addConfiglets(self, out)
    
    print >> out, ' done.\n'

    return out.getvalue()

def uninstall(self):
    out = StringIO()

    removeConfiglets(self, out)
    print >> out, ' done.\n'

    return out.getvalue()

